package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.TSSDGroupDetail;
import com.sa.ibiz.demo.demo.service.TSSDGroupDetailService;
import com.sa.ibiz.demo.demo.service.dto.TSSDGroupDetailSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/tssdgroupdetail")
public class TSSDGroupDetailResource
{
	@Autowired
	private TSSDGroupDetailService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<TSSDGroupDetail> checkKey(@Validated @RequestBody TSSDGroupDetail data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略组明细[checkKey]操作发生错误","TSSDGroupDetail",data.getTssdgroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<TSSDGroupDetail> update(@Validated @RequestBody TSSDGroupDetail data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略组明细[update]操作发生错误","TSSDGroupDetail",data.getTssdgroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<TSSDGroupDetail> get(@Validated @PathVariable String id){
		TSSDGroupDetail data=new TSSDGroupDetail();
		data.setTssdgroupdetailid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("任务时刻策略组明细[get]操作发生错误","TSSDGroupDetail",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<TSSDGroupDetail> getDraft(@Validated @RequestBody TSSDGroupDetail data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略组明细[getDraft]操作发生错误","TSSDGroupDetail","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<TSSDGroupDetail> create(@Validated @RequestBody TSSDGroupDetail data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略组明细[create]操作发生错误","TSSDGroupDetail",data.getTssdgroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<TSSDGroupDetail> remove(@Validated @RequestBody TSSDGroupDetail data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略组明细[remove]操作发生错误","TSSDGroupDetail",data.getTssdgroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<TSSDGroupDetail>> searchDefaultPage(@Validated @RequestBody TSSDGroupDetailSearchFilter filter){
		Page<TSSDGroupDetail> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<TSSDGroupDetail>> listDefault(@Validated @RequestBody TSSDGroupDetailSearchFilter filter){
		List<TSSDGroupDetail> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
